/*
		    TTTTTTT    OOOOO    7777777
		       T      O     O        7
		       T      O     O       7
		       T      O     O      7
		       T      O     O     7
		       T       OOOOO     7

			     EMULATEUR

			  Par Sylvain HUET
		(sylvain.huet@polytechnique.org)
				  1994-2002
	
	  harddisplay.c : routine GAPI pocketpc de l'emulateur
	  
*/


#include <windows.h>
#include <windowsx.h>
#include <wingdi.h>
#include <commctrl.h>
#include <commdlg.h>
#include <string.h>


#include "gx.h"

#include "harddisplay.h"

GXDisplayProperties g_gxdp;		// GX struct
GXKeyList g_gxkl;				// GX struct
short* screenpnt;


int gohard(HWND win)
{
	if (GXOpenDisplay(win, GX_FULLSCREEN) == 0) return -1;	// we won't be able to draw.

	// Initialize the Hardware Buttons
	GXOpenInput();

	// Get the Display properties
	g_gxdp = GXGetDisplayProperties();
	// Get information about the Hardware Keys
	g_gxkl = GXGetDefaultKeys(GX_NORMALKEYS);

	if (g_gxdp.cBPP==16) return 0;

	return -2;	// mauvaise rsolution
}

void stophard()
{
	GXCloseDisplay();
	GXCloseInput();
}

short* takescreen()
{
	return (short *)GXBeginDraw();
}

void releasescreen()
{
	GXEndDraw();
}

int offscreen(int x,int y)
{
	return (x*g_gxdp.cbxPitch+y*g_gxdp.cbyPitch)>>1;	// on retourne en short*
}

short rgbtohard(int r,int g,int b)
{
	if (g_gxdp.ffFormat | kfDirect565)
	{
		return (short)((r&0xf8)<<8)+((g&0xfc)<<3)+((b&0xf8)>>3);
	}
	else if (g_gxdp.ffFormat | kfDirect555)
	{
		return (short)((r&0xf8)<<7)+((g&0xf8)<<2)+((b&0xf8)>>3);
	}
	return 0;
}

